<template>
  <div class="py-8 mt-10 md:mt-0 px-4 lg:py-16 lg:px-12">
    <section class="bg-white dark:bg-gray-900">
      <UBreadcrumb :links="links" />
      <div class="py-8 px-4 mx-auto max-w-2xl lg:py-16">
        <h2 class="mb-4 text-xl font-bold text-gray-900 dark:text-white">
          Ajout nouveau utilisateur
        </h2>
        <p>{{ error }}</p>
        <UForm :schema="schema" :state="state" @submit="onSubmit">
          <div class="grid gap-4 sm:grid-cols-2 sm:gap-6">
            <div class="sm:col-span-2">
              <UFormGroup label="Nom" name="name" class="block mb-2 text-sm font-medium !text-gray-900">
                <UInput type="text" v-model="state.username" placeholder="Jhon" inputClass="!bg-gray-50 !text-gray-900 sm:text-sm rounded-lg block w-full p-2.5" />
              </UFormGroup>
            </div>
            <div class="w-full">
              <UFormGroup label="Email" name="email" class="block mb-2 text-sm font-medium !text-gray-900">
                <UInput type="email" v-model="state.email" placeholder="jhon@example.com" inputClass="!bg-gray-50 !text-gray-900 sm:text-sm rounded-lg block w-full p-2.5" />
              </UFormGroup>
            </div>
            <div class="w-full">
              <UFormGroup label="Mot de passe" name="password" class="block mb-2 text-sm font-medium !text-gray-900">
                <UInput type="password" v-model="state.password" placeholder="••••••••" inputClass="!bg-gray-50 !text-gray-900 sm:text-sm rounded-lg block w-full p-2.5" />
              </UFormGroup>>
            </div>
          </div>
          <UButton type="submit" :loading="loading" class="w-full text-white bg-primary-600 hover:bg-primary-700 focus:ring-4 focus:outline-none focus:ring-primary-300 font-medium rounded-lg text-sm px-5 py-2.5 text-center">
            Créer utilisateur
          </UButton>
        </UForm>
      </div>
    </section>
  </div>
</template>

<script setup lang="ts">
import { object, string, boolean, type InferType } from 'yup'
import type { FormSubmitEvent } from '#ui/types'
import {useNuxtApp} from "#app";
import type {Api} from "~/types/api";
import {useAuthStore} from "~/store/auth";
import is from "@sindresorhus/is";
import undefined = is.undefined;


const loading = ref(false)
const error = ref('')
const links = [{
  label: 'Home',
  icon: 'i-heroicons-home',
  to: '/feed'
}, {
  label: 'Utilisateurs',
  icon: 'i-heroicons-users-solid',
  to: '/users'
}, {
  label: 'Nouveau',
  icon: 'i-heroicons-user-plus-16-solid'
}]

const schema = object({
  username: string().max(50, 'Le contenu est trop long').required('Champs obligatoire'),
  email: string().email('Email invalide').required('Champs obligatoire'),
  password: string()
      .min(8, 'Dois contenir au moins 8 caractères')
      .required('Champs obligatoire')
})

type Schema = InferType<typeof schema>

const state = reactive({
  username: '',
  email: '',
  password: ''
})

const nuxtApp = useNuxtApp()
const $api = nuxtApp.$api as Api
const router = useRouter()
const toast = useToast()

async function onSubmit (event: FormSubmitEvent<Schema>) {
  loading.value = true
  const data = ref({
    username: event.data.username,
    email: event.data.email,
    password: event.data.password,
    isAdmin: true
  })
  const response = await $api.register(data.value)
  if (response) {
    toast.add({ title: 'Utilisateur créé' })
    await router.push('/users')
  } else {
    error.value = 'Un problème est survenu'
  }
  loading.value = false
}
</script>